(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('moment'), require('@angular/core'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('ngx-utilitario-rclt', ['exports', '@angular/common', 'moment', '@angular/core', '@angular/forms'], factory) :
    (factory((global['ngx-utilitario-rclt'] = {}),global.ng.common,global.moment_,global.ng.core,global.ng.forms));
}(this, (function (exports,common,moment_,i0,forms) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CardsComponent = /** @class */ (function () {
        function CardsComponent() {
            /**
             * recibe el icono a usar
             */
            this.icono = "fa fa-user";
            this.classTexto = "w-80 float-left";
            /**
             * Enviar el tamaño de columnas y el tamaño del icono
             */
            this.classIcono = "w-20 fontSize2-5 cardIcono";
            this.color = "#7a5449";
            this.click = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        CardsComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        CardsComponent.prototype.clickCard = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.click.emit($event);
            };
        CardsComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-cards',
                        template: "<div class=\"cards\" (click)=\"clickCard($event)\">\n        <div [ngClass]=\"classTexto\">\n            <h2 class=\"cardsTitulo\">{{titulo}}</h2>\n            <h3 class=\"cardsSubtitulo\">{{subtitulo}}</h3>\n            <h3 class=\"cardsContenido\"><ng-content></ng-content></h3>\n        </div>\n    \n        <div [ngClass]=\"classIcono\">\n            <i class=\"{{icono}} float-right cardIcono\" [style.color]=\"color\"></i>\n        </div>\n    </div>",
                        styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left}.cards:hover{background-color:rgba(0,0,0,.05)}.cardsTitulo{font-size:.75rem;font-weight:700;text-transform:uppercase;color:#595959;padding:1rem 0 0 1.2rem;margin:0}.cardsSubtitulo{color:#b0b0b0;font-size:1.5rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardIcono{padding:.5rem 1rem 0}.classIcono{display:table-cell;width:auto}.fontSize2-5{font-size:2.5rem;padding-right:0}"]
                    }] }
        ];
        /** @nocollapse */
        CardsComponent.ctorParameters = function () { return []; };
        CardsComponent.propDecorators = {
            titulo: [{ type: i0.Input }],
            subtitulo: [{ type: i0.Input }],
            icono: [{ type: i0.Input }],
            classTexto: [{ type: i0.Input }],
            classIcono: [{ type: i0.Input }],
            color: [{ type: i0.Input }],
            click: [{ type: i0.Output }]
        };
        return CardsComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CardsImgTextComponent = /** @class */ (function () {
        function CardsImgTextComponent() {
            this.descripcion = "afdasdf";
            this.etiqueta = "etiqueta";
            this.imagen = './assets/test.jpg';
            /**
             * recibe el icono a usar
             */
            this.icono = "fa fa-user";
            this.classTexto = "w-80 float-left";
            /**
             * Enviar el tamaño de columnas y el tamaño del icono
             */
            this.classIcono = "col-1 align-middle cardIcono";
            this.color = "#000";
            this.height = "6.5rem";
            this.click = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        CardsImgTextComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        CardsImgTextComponent.prototype.clickCard = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.click.emit($event);
            };
        CardsImgTextComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-cards-img-text',
                        template: "<div class=\"row cards row-no-padding\" [style.color]=\"color\" (click)=\"clickCard($event)\">\n    <div class=\"col-2 float-left\">\n        <img class=\"cardsImagen\" src={{imagen}} [style.height]=\"height\" />\n    </div>\n    <div class=\"col-9\">\n        <div [ngClass]=\"classTexto\">\n            <h2 class=\"cardsTitulo\" [style.color]=\"color\">{{titulo}}</h2>\n            <h3 class=\"cardsDescripcion\">{{descripcion}}</h3>\n            <h3 class=\"cardsEtiqueta\" [style.background]=\"color\">{{etiqueta}}</h3>\n            <h3 class=\"cardsContenido\">\n                <ng-content></ng-content>\n            </h3>\n        </div>\n    </div>\n    <div [ngClass]=\"classIcono\">\n        <i class=\"{{icono}} float-right cardIcono\"></i>\n    </div>\n</div>",
                        styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left;display:table!important;margin:10px 0;box-shadow:0 1px 2px rgba(0,0,0,.2);transition:.5s}.cards:hover{background-color:rgba(0,0,0,.05);-webkit-transform:translateX(5px);transform:translateX(5px)}.cardsImagen{width:100%;-o-object-fit:fill;object-fit:fill}.cardsTitulo{font-size:1.25rem;font-weight:700;color:#595959;padding:.35rem 0 0 1.2rem;margin:0}.cardsDescripcion{color:#b0b0b0;font-size:1rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardsEtiqueta{display:inline-block;margin:0 0 0 1.2rem;padding:.25rem .5rem;color:#fff;font-size:.6rem;text-transform:capitalize;border-radius:.25rem}.classIcono{vertical-align:middle}.cardIcono{padding:.7rem .5rem .5rem 0;display:table-cell;width:auto}.fontSize40{font-size:2.5rem;padding-right:0}"]
                    }] }
        ];
        /** @nocollapse */
        CardsImgTextComponent.ctorParameters = function () { return []; };
        CardsImgTextComponent.propDecorators = {
            titulo: [{ type: i0.Input }],
            descripcion: [{ type: i0.Input }],
            etiqueta: [{ type: i0.Input }],
            imagen: [{ type: i0.Input }],
            icono: [{ type: i0.Input }],
            classTexto: [{ type: i0.Input }],
            classIcono: [{ type: i0.Input }],
            color: [{ type: i0.Input }],
            height: [{ type: i0.Input }],
            click: [{ type: i0.Output }]
        };
        return CardsImgTextComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RepeatIconComponent = /** @class */ (function () {
        function RepeatIconComponent() {
            this.repetir = 5;
            this.activo = 0;
            this.icono = "fa fa-user";
            this.color = "#000";
            this.colorActivo = "#000";
        }
        /**
         * @return {?}
         */
        RepeatIconComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        RepeatIconComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-repeat-icon',
                        template: "<ng-container class=\"repetirIcono\">\n    <i *ngFor=\"let item of activo | numberToArray\" class=\"{{icono}}\" [style.color]=\"colorActivo\"></i>\n    <i *ngFor=\"let item of (repetir - activo) | numberToArray\" class=\"{{icono}}\" [style.color]=\"color\"></i>\n</ng-container>",
                        styles: [".repetirIcono{display:inline-flex}"]
                    }] }
        ];
        /** @nocollapse */
        RepeatIconComponent.ctorParameters = function () { return []; };
        RepeatIconComponent.propDecorators = {
            repetir: [{ type: i0.Input }],
            activo: [{ type: i0.Input }],
            icono: [{ type: i0.Input }],
            color: [{ type: i0.Input }],
            colorActivo: [{ type: i0.Input }]
        };
        return RepeatIconComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NumberToArrayPipe = /** @class */ (function () {
        function NumberToArrayPipe() {
        }
        /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
        NumberToArrayPipe.prototype.transform = /**
         * @param {?} value
         * @param {?=} args
         * @return {?}
         */
            function (value, args) {
                /** @type {?} */
                var res = [];
                for (var i = 0; i < value; i++) {
                    res.push(i);
                }
                return res;
            };
        NumberToArrayPipe.decorators = [
            { type: i0.Pipe, args: [{
                        name: 'numberToArray'
                    },] }
        ];
        return NumberToArrayPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CardsImgTextNdivComponent = /** @class */ (function () {
        function CardsImgTextNdivComponent() {
            this.descripcion = "afdasdf";
            this.etiqueta = "etiqueta";
            this.imagen = './assets/test.jpg';
            this.classTexto = "float-left";
            this.color = "#000";
            this.height = "6.5rem";
            this.contenido = [];
            this.click = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        CardsImgTextNdivComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} $event
         * @return {?}
         */
        CardsImgTextNdivComponent.prototype.clickCard = /**
         * @param {?} $event
         * @return {?}
         */
            function ($event) {
                this.click.emit($event);
            };
        CardsImgTextNdivComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-cards-img-text-ndiv',
                        template: "<div class=\"cards row row-no-padding\" [style.color]=\"color\" (click)=\"clickCard($event)\">\n    <div class=\"col-2 float-left\">\n        <img class=\"cardsImagen\" src={{imagen}} [style.height]=\"height\" />\n    </div>\n    <div class=\"col-{{10 - contenido.length }} float-left\">\n        <div [ngClass]=\"classTexto\">\n            <h2 class=\"cardsTitulo\" [style.color]=\"color\">{{titulo}}</h2>\n            <h3 class=\"cardsDescripcion\">{{descripcion}}</h3>\n            <h3 class=\"cardsEtiqueta\" [style.background]=\"color\">{{etiqueta}}</h3>\n            <h3 class=\"cardsContenido\">\n                <ng-content></ng-content>\n            </h3>\n        </div>\n    </div>\n    <div *ngFor=\"let item of contenido\" class=\"col-1 float-left center-middle text-center\" style=\"color:#000\" [style.line-height]=\"height\">\n        <ng-content *ngIf=\"item==='content'\"></ng-content>\n        <span *ngIf=\"item!=='content'\">{{item}}</span>\n    </div>\n</div>",
                        styles: [".cards{background:#fff;box-shadow:rgba(0,0,0,.1);cursor:pointer;width:100%;float:left;display:table!important;box-shadow:0 1px 2px rgba(0,0,0,.2);transition:.5s;margin:10px 0}.cards:hover{background-color:rgba(0,0,0,.05);-webkit-transform:translateX(5px);transform:translateX(5px)}.cardsImagen{width:100%;-o-object-fit:fill;object-fit:fill}.cardsTitulo{font-size:1.25rem;font-weight:700;color:#595959;padding:.35rem 0 0 1.2rem;margin:0}.cardsDescripcion{color:#b0b0b0;font-size:1rem;font-weight:600;line-height:1.5;padding:0 0 0 1.2rem}.cardsContenido{color:#595959;font-size:1rem;font-weight:500;line-height:1.2;padding:0 0 0 1.2rem}.cardsEtiqueta{display:inline-block;margin:0 0 0 1.2rem;padding:.25rem .5rem;color:#fff;font-size:.6rem;text-transform:capitalize;border-radius:.25rem}.classIcono{vertical-align:middle}.cardIcono{padding:.7rem .5rem .5rem 0;display:table-cell;width:auto}.fontSize40{font-size:2.5rem;padding-right:0}", ".row-no-padding [class*=col-]{padding-left:0!important;padding-right:0!important}"]
                    }] }
        ];
        /** @nocollapse */
        CardsImgTextNdivComponent.ctorParameters = function () { return []; };
        CardsImgTextNdivComponent.propDecorators = {
            titulo: [{ type: i0.Input }],
            descripcion: [{ type: i0.Input }],
            etiqueta: [{ type: i0.Input }],
            imagen: [{ type: i0.Input }],
            classTexto: [{ type: i0.Input }],
            color: [{ type: i0.Input }],
            height: [{ type: i0.Input }],
            contenido: [{ type: i0.Input }],
            click: [{ type: i0.Output }]
        };
        return CardsImgTextNdivComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalService = /** @class */ (function () {
        function ModalService() {
            this.modals = [];
        }
        /**
         * @param {?} modal
         * @return {?}
         */
        ModalService.prototype.add = /**
         * @param {?} modal
         * @return {?}
         */
            function (modal) {
                this.modals.push(modal);
            };
        /**
         * @param {?} id
         * @return {?}
         */
        ModalService.prototype.remove = /**
         * @param {?} id
         * @return {?}
         */
            function (id) {
                this.modals = this.modals.filter(( /**
                 * @param {?} x
                 * @return {?}
                 */function (x) { return x.id !== id; }));
            };
        /**
         * @param {?} id
         * @return {?}
         */
        ModalService.prototype.open = /**
         * @param {?} id
         * @return {?}
         */
            function (id) {
                /** @type {?} */
                var modal = this.modals.filter(( /**
                 * @param {?} x
                 * @return {?}
                 */function (x) { return x.id === id; }))[0];
                modal.open();
            };
        /**
         * @param {?} id
         * @return {?}
         */
        ModalService.prototype.close = /**
         * @param {?} id
         * @return {?}
         */
            function (id) {
                /** @type {?} */
                var modal = this.modals.filter(( /**
                 * @param {?} x
                 * @return {?}
                 */function (x) { return x.id === id; }))[0];
                modal.close();
            };
        ModalService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: 'root'
                    },] }
        ];
        /** @nocollapse */
        ModalService.ctorParameters = function () { return []; };
        /** @nocollapse */ ModalService.ngInjectableDef = i0.defineInjectable({ factory: function ModalService_Factory() { return new ModalService(); }, token: ModalService, providedIn: "root" });
        return ModalService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalComponent = /** @class */ (function () {
        function ModalComponent(modalService, el) {
            this.modalService = modalService;
            this.el = el;
            this.element = el.nativeElement;
        }
        /**
         * @return {?}
         */
        ModalComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                /** @type {?} */
                var modal = this;
                // ensure id attribute exists
                if (!this.id) {
                    console.error('modal must have an id');
                    return;
                }
                // move element to bottom of page (just before </body>) so it can be displayed above everything else
                document.body.appendChild(this.element);
                // close modal on background click
                this.element.addEventListener('click', ( /**
                 * @param {?} e
                 * @return {?}
                 */function (e) {
                    if (e.target.className === 'ngx-utilitario-modal') {
                        modal.close();
                    }
                }));
                // add self (this modal instance) to the modal service so it's accessible from controllers
                this.modalService.add(this);
                this.close();
            };
        // remove self from modal service when component is destroyed
        // remove self from modal service when component is destroyed
        /**
         * @return {?}
         */
        ModalComponent.prototype.ngOnDestroy =
            // remove self from modal service when component is destroyed
            /**
             * @return {?}
             */
            function () {
                this.modalService.remove(this.id);
                this.element.remove();
            };
        // open modal
        // open modal
        /**
         * @return {?}
         */
        ModalComponent.prototype.open =
            // open modal
            /**
             * @return {?}
             */
            function () {
                this.element.style.display = 'block';
                document.body.classList.add('ngx-utilitario-modal-open');
                console.log('fasd');
            };
        // close modal
        // close modal
        /**
         * @return {?}
         */
        ModalComponent.prototype.close =
            // close modal
            /**
             * @return {?}
             */
            function () {
                this.element.style.display = 'none';
                document.body.classList.remove('ngx-utilitario-modal-open');
            };
        ModalComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-modal',
                        template: "<div class=\"ngx-utilitario-modal\">\n    <div class=\"ngx-utilitario-modal-body\">\n      <ng-content></ng-content>\n    </div>\n  </div>\n  <div class=\"ngx-utilitario-modal-background\"></div>",
                        styles: [".ngx-utilitario-modal{position:fixed;top:0;right:0;bottom:0;left:0;z-index:1000;overflow:auto}.ngx-utilitario-modal .ngx-utilitario-modal-body{padding:20px;background:#fff;margin:40px}.ngx-utilitario-modal-background{position:fixed;top:0;right:0;bottom:0;left:0;background-color:#000;opacity:.75;z-index:900}"]
                    }] }
        ];
        /** @nocollapse */
        ModalComponent.ctorParameters = function () {
            return [
                { type: ModalService },
                { type: i0.ElementRef }
            ];
        };
        ModalComponent.propDecorators = {
            id: [{ type: i0.Input }]
        };
        return ModalComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChatComponent = /** @class */ (function () {
        function ChatComponent() {
            this.lista = [];
            this.nuevoMensaje = new i0.EventEmitter();
            this.clickLista = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        ChatComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} detalle
         * @return {?}
         */
        ChatComponent.prototype.clickListaDetalle = /**
         * @param {?} detalle
         * @return {?}
         */
            function (detalle) {
                this.clickLista.emit(detalle);
                this.cambiarConversacion(detalle);
                console.log(detalle);
            };
        /**
         * @param {?} detalle
         * @return {?}
         */
        ChatComponent.prototype.cambiarConversacion = /**
         * @param {?} detalle
         * @return {?}
         */
            function (detalle) {
                this.conversacion.estado = detalle.estado;
                this.conversacion.nombre = detalle.nombre;
                this.conversacion.id = detalle.id;
                this.conversacion.mensajes = detalle.mensaje;
                this.conversacion.img = detalle.img;
            };
        /**
         * @param {?} mensaje
         * @return {?}
         */
        ChatComponent.prototype.enviarMensaje = /**
         * @param {?} mensaje
         * @return {?}
         */
            function (mensaje) {
                this.conversacion.mensajes = mensaje;
                this.nuevoMensaje.emit(this.conversacion);
            };
        ChatComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-chat',
                        template: "<div class=\"row\">\n  <div class=\"col-4\">\n      <header class=\"header-chat\">\n        Chats\n        <span class=\"fa fa-pencil-square-o\"></span>\n      </header>\n      <ngx-utilitario-chat-busqueda></ngx-utilitario-chat-busqueda>\n      <ngx-utilitario-chat-lista [lista]=\"lista\" (clickLista)=\"clickListaDetalle($event)\"></ngx-utilitario-chat-lista>\n    </div>\n    <div class=\"col-8\">\n      <ngx-utilitario-chat-conversacion [conversacion]=\"conversacion\" (nuevoMensaje)=\"enviarMensaje($event)\"></ngx-utilitario-chat-conversacion>\n    </div>\n</div>",
                        styles: [".header-chat{background:#fff;color:324148;padding:22px 15px;border-bottom:1px solid #e0e3e4;text-align:center;font-size:18px;font-weight:600;font-family:Lato,sans-serif}.header-chat span{float:right;font-size:inherit}"]
                    }] }
        ];
        /** @nocollapse */
        ChatComponent.ctorParameters = function () { return []; };
        ChatComponent.propDecorators = {
            lista: [{ type: i0.Input }],
            conversacion: [{ type: i0.Input }],
            nuevoMensaje: [{ type: i0.Output }],
            clickLista: [{ type: i0.Output }]
        };
        return ChatComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChatBusquedaComponent = /** @class */ (function () {
        function ChatBusquedaComponent() {
        }
        /**
         * @return {?}
         */
        ChatBusquedaComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        ChatBusquedaComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-chat-busqueda',
                        template: "<div class=\"content ngx-utilitario-busqueda\">\n  <input class=\"col-12 ngx-utilitario-busqueda-input\" type=\"text\" placeholder=\"Busqueda\">\n</div>",
                        styles: [".ngx-utilitario-busqueda{padding:15px;background:#ececec;box-sizing:border-box}.ngx-utilitario-busqueda-input{background:#fff;border-radius:50px;box-shadow:none;border:none;border-bottom:1px solid rgba(255,255,255,.2);padding:12px}.ngx-utilitario-busqueda-input:focus{outline:0}"]
                    }] }
        ];
        /** @nocollapse */
        ChatBusquedaComponent.ctorParameters = function () { return []; };
        return ChatBusquedaComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChatListaComponent = /** @class */ (function () {
        function ChatListaComponent() {
            this.lista = [];
            this.clickLista = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        ChatListaComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} detalle
         * @return {?}
         */
        ChatListaComponent.prototype.click = /**
         * @param {?} detalle
         * @return {?}
         */
            function (detalle) {
                this.clickLista.emit(detalle);
            };
        ChatListaComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-chat-lista',
                        template: "<ngx-utilitario-chat-detalle *ngFor=\"let item of lista\" [detalle]=\"item\" (clickDetalle)=\"click($event)\"></ngx-utilitario-chat-detalle>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ChatListaComponent.ctorParameters = function () { return []; };
        ChatListaComponent.propDecorators = {
            lista: [{ type: i0.Input }],
            clickLista: [{ type: i0.Output }]
        };
        return ChatListaComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @type {?} */
    var moment = moment_;
    var Fecha = /** @class */ (function () {
        function Fecha() {
            this.now = new Date();
        }
        /**
         * Compara si la fecha1 es mayor a la fecha2 si no se envia la fecha2 se tomara la fecha actual
         * @param fecha1
         * @param fecha2
         */
        /**
         * Compara si la fecha1 es mayor a la fecha2 si no se envia la fecha2 se tomara la fecha actual
         * @param {?} fecha1
         * @param {?=} fecha2
         * @return {?}
         */
        Fecha.prototype.compararFechas = /**
         * Compara si la fecha1 es mayor a la fecha2 si no se envia la fecha2 se tomara la fecha actual
         * @param {?} fecha1
         * @param {?=} fecha2
         * @return {?}
         */
            function (fecha1, fecha2) {
                /** @type {?} */
                var fec1 = moment(fecha1);
                if (fecha2 === undefined) {
                    fecha2 = new Date();
                }
                /** @type {?} */
                var fec2 = moment(fecha2);
                if (fec1.startOf('day').isSame(fec2.startOf('day'))) {
                    return true;
                }
                return false;
            };
        /**
         * Cuenta los dias entre la fecha1 y la fecha2. si no se envia la fecha 2 se tomara la fecha actual
         * @param fecha1
         * @param fecha2
         */
        /**
         * Cuenta los dias entre la fecha1 y la fecha2. si no se envia la fecha 2 se tomara la fecha actual
         * @param {?} fecha1
         * @param {?=} fecha2
         * @return {?}
         */
        Fecha.prototype.diferenciaDias = /**
         * Cuenta los dias entre la fecha1 y la fecha2. si no se envia la fecha 2 se tomara la fecha actual
         * @param {?} fecha1
         * @param {?=} fecha2
         * @return {?}
         */
            function (fecha1, fecha2) {
                /** @type {?} */
                var fec1 = moment(fecha1);
                if (fecha2 === undefined) {
                    fecha2 = new Date();
                }
                /** @type {?} */
                var fec2 = moment(fecha2);
                return fec1.diff(fec2, 'days', false);
            };
        /**
         * Cuenta los dias entre la fecha1 y la fecha2. si no se envia la fecha 2 se tomara la fecha actual
         * el formato que se devolvera la fecha "moment"
         * @param fecha1
         * @param fecha2
         * @param format
         */
        /**
         * Cuenta los dias entre la fecha1 y la fecha2. si no se envia la fecha 2 se tomara la fecha actual
         * el formato que se devolvera la fecha "moment"
         * @param {?} fecha1
         * @param {?=} fecha2
         * @param {?=} format
         * @return {?}
         */
        Fecha.prototype.textoDiferenciaDias = /**
         * Cuenta los dias entre la fecha1 y la fecha2. si no se envia la fecha 2 se tomara la fecha actual
         * el formato que se devolvera la fecha "moment"
         * @param {?} fecha1
         * @param {?=} fecha2
         * @param {?=} format
         * @return {?}
         */
            function (fecha1, fecha2, format) {
                /** @type {?} */
                var fec1 = moment(fecha1);
                /** @type {?} */
                var dias = this.diferenciaDias(fecha1, fecha2);
                if (format === undefined) {
                    format = 'DD/MM/YYYY';
                }
                switch (dias) {
                    case 0: {
                        return "Hoy";
                    }
                    case 1: {
                        return "Mañana";
                    }
                    case -1: {
                        return "Ayer";
                    }
                    default: {
                        return fec1.format(format);
                    }
                }
            };
        /**
         * Aplicar el formato a una fecha con moment
         * L    = Date (in local format)
         * LL   = Month name, day of month, year
         * LLL  = Month name, day of month, year, time
         * LLLL = Day of week, month name, day of month, year, time
         * LT   = Time (without seconds)
         * LTS  = Time (with seconds)
         * H HH = Time (with seconds)
         * @param fecha
         * @param format
         */
        /**
         * Aplicar el formato a una fecha con moment
         * L    = Date (in local format)
         * LL   = Month name, day of month, year
         * LLL  = Month name, day of month, year, time
         * LLLL = Day of week, month name, day of month, year, time
         * LT   = Time (without seconds)
         * LTS  = Time (with seconds)
         * H HH = Time (with seconds)
         * @param {?} fecha
         * @param {?} format
         * @return {?}
         */
        Fecha.prototype.format = /**
         * Aplicar el formato a una fecha con moment
         * L    = Date (in local format)
         * LL   = Month name, day of month, year
         * LLL  = Month name, day of month, year, time
         * LLLL = Day of week, month name, day of month, year, time
         * LT   = Time (without seconds)
         * LTS  = Time (with seconds)
         * H HH = Time (with seconds)
         * @param {?} fecha
         * @param {?} format
         * @return {?}
         */
            function (fecha, format) {
                /** @type {?} */
                var fec1 = moment(fecha);
                return fec1.format(format);
            };
        return Fecha;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChatDetalleComponent = /** @class */ (function () {
        function ChatDetalleComponent() {
            this.clickDetalle = new i0.EventEmitter();
            this.fecha = new Fecha();
        }
        /**
         * @return {?}
         */
        ChatDetalleComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @return {?}
         */
        ChatDetalleComponent.prototype.click = /**
         * @return {?}
         */
            function () {
                this.clickDetalle.emit(this.detalle);
            };
        /**
         * @param {?} mensajes
         * @return {?}
         */
        ChatDetalleComponent.prototype.ultimoMensaje = /**
         * @param {?} mensajes
         * @return {?}
         */
            function (mensajes) {
                if (mensajes.length > 0) {
                    if (mensajes[mensajes.length - 1].img === null)
                        return mensajes[mensajes.length - 1].mensaje;
                    else
                        return 'Foto';
                }
                return '';
            };
        /**
         * @param {?} mensajes
         * @return {?}
         */
        ChatDetalleComponent.prototype.ultimaFecha = /**
         * @param {?} mensajes
         * @return {?}
         */
            function (mensajes) {
                if (mensajes.length > 0) {
                    if (this.fecha.compararFechas(new Date(mensajes[mensajes.length - 1].fecha)))
                        return mensajes[mensajes.length - 1].hora;
                    else {
                        return mensajes[mensajes.length - 1].fecha;
                    }
                }
                return '';
            };
        ChatDetalleComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-chat-detalle',
                        template: "<div class=\"content ngx-utilitario-chat-detalle\" (click)=\"click()\">\n  <div class=\"row\">\n    <div class=\"col-2\">\n      <img class=\"img-fluid rounded-circle\" src={{detalle.img}} />\n      <div *ngIf=\"detalle.estado\" class=\"estadoConectado\">\n      </div>\n    </div>\n    <div class=\"col-8\">\n      <div class=\"content\">\n        {{detalle.nombre}}\n      </div>\n      <div class=\"content\">\n        {{ultimoMensaje(detalle.mensaje)}}\n      </div>\n    </div>\n    <div class=\"col-2 float-right text-right ngx-utilitario-fecha-not-chat\">\n      <div class=\"content ngx-utilitario-fecha-chat\">\n        {{ultimaFecha(detalle.mensaje)}}\n      </div>\n      <div *ngIf=\"detalle.notificacion>0\" class=\"content ngx-utilitario-label-notificacion\">\n        {{detalle.notificacion}}\n      </div>\n    </div>\n  </div>\n</div>",
                        styles: [".ngx-utilitario-chat-detalle{padding:.9rem;cursor:pointer}.ngx-utilitario-fecha-not-chat{padding:0}.ngx-utilitario-label-notificacion{background-color:#e7b723;padding:4px 8px;color:#fff;display:inline-block;border-radius:.6rem}.ngx-utilitario-fecha-chat{font-size:.7rem}.estadoConectado{background:#22af47;border:1px solid #fff;width:10px;height:10px;position:absolute;border-radius:50%;right:0;bottom:0}"]
                    }] }
        ];
        /** @nocollapse */
        ChatDetalleComponent.ctorParameters = function () { return []; };
        ChatDetalleComponent.propDecorators = {
            detalle: [{ type: i0.Input }],
            clickDetalle: [{ type: i0.Output }]
        };
        return ChatDetalleComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var ETipoMensaje = {
        enviado: 1,
        recibido: 0,
    };
    ETipoMensaje[ETipoMensaje.enviado] = 'enviado';
    ETipoMensaje[ETipoMensaje.recibido] = 'recibido';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EEstadoMensaje = {
        enviado: 0,
        recibido: 1,
        leido: 2,
    };
    EEstadoMensaje[EEstadoMensaje.enviado] = 'enviado';
    EEstadoMensaje[EEstadoMensaje.recibido] = 'recibido';
    EEstadoMensaje[EEstadoMensaje.leido] = 'leido';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChatConversacionComponent = /** @class */ (function () {
        function ChatConversacionComponent() {
            this.conversacion = {
                id: '',
                img: '',
                nombre: '',
                estado: null,
                mensajes: []
            };
            this.nuevoMensaje = new i0.EventEmitter();
            this.fecha = undefined;
            this.fecha = new Fecha();
        }
        /**
         * @return {?}
         */
        ChatConversacionComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
            };
        /**
         * @param {?} fecha
         * @param {?} index
         * @return {?}
         */
        ChatConversacionComponent.prototype.lineaDia = /**
         * @param {?} fecha
         * @param {?} index
         * @return {?}
         */
            function (fecha, index) {
                /** @type {?} */
                var tDate;
                if (index === 0) {
                    tDate = new Date(fecha);
                    tDate.setDate(tDate.getDate() - 1);
                }
                else {
                    tDate = new Date(this.conversacion.mensajes[index - 1].fecha);
                }
                return !this.fecha.compararFechas(new Date(fecha), tDate);
            };
        /**
         * @param {?} fecha
         * @return {?}
         */
        ChatConversacionComponent.prototype.diferenciaDias = /**
         * @param {?} fecha
         * @return {?}
         */
            function (fecha) {
                return this.fecha.textoDiferenciaDias(fecha);
            };
        /**
         * @param {?} tipoMensaje
         * @return {?}
         */
        ChatConversacionComponent.prototype.escogerEstilo = /**
         * @param {?} tipoMensaje
         * @return {?}
         */
            function (tipoMensaje) {
                if (tipoMensaje === ETipoMensaje.enviado) {
                    return "float-right";
                }
                return "float-left";
            };
        /**
         * @param {?} estado
         * @param {?} tipoMensaje
         * @return {?}
         */
        ChatConversacionComponent.prototype.estadoMensajeEnviado = /**
         * @param {?} estado
         * @param {?} tipoMensaje
         * @return {?}
         */
            function (estado, tipoMensaje) {
                if (estado === EEstadoMensaje.enviado && tipoMensaje === ETipoMensaje.enviado)
                    return true;
                return false;
            };
        /**
         * @param {?} estado
         * @param {?} tipoMensaje
         * @return {?}
         */
        ChatConversacionComponent.prototype.estadoMensajeRecibido = /**
         * @param {?} estado
         * @param {?} tipoMensaje
         * @return {?}
         */
            function (estado, tipoMensaje) {
                if (estado === EEstadoMensaje.recibido && tipoMensaje === ETipoMensaje.enviado)
                    return true;
                return false;
            };
        /**
         * @param {?} estado
         * @param {?} tipoMensaje
         * @return {?}
         */
        ChatConversacionComponent.prototype.estadoMensajeLeido = /**
         * @param {?} estado
         * @param {?} tipoMensaje
         * @return {?}
         */
            function (estado, tipoMensaje) {
                if (estado === EEstadoMensaje.leido && tipoMensaje === ETipoMensaje.enviado)
                    return true;
                return false;
            };
        /**
         * @param {?} mensaje
         * @return {?}
         */
        ChatConversacionComponent.prototype.enviarMensaje = /**
         * @param {?} mensaje
         * @return {?}
         */
            function (mensaje) {
                /** @type {?} */
                var nuevoMensaje = {
                    estadoMensaje: EEstadoMensaje.enviado,
                    fecha: new Fecha().format(new Date(), 'LL'),
                    hora: new Fecha().format(new Date(), 'HH:mm'),
                    img: null,
                    mensaje: mensaje,
                    tipoMensaje: ETipoMensaje.enviado
                };
                this.nuevoMensaje.emit(nuevoMensaje);
            };
        ChatConversacionComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-chat-conversacion',
                        template: "<div class=\"col-12\">\n  <div class=\"row\">\n    <div class=\"col-2 img-fluid\">\n      <img class=\"img-fluid rounded-circle img-height-3-7\" src=\"{{conversacion.img}}\" />\n    </div>\n    <div class=\"col-9\">\n      <div class=\"row\">\n        <div class=\"col-12\">\n          {{conversacion.nombre}}\n        </div>\n      </div>\n      <div class=\"row\">\n        <div class=\"col-12\">{{conversacion.estado}}</div>\n      </div>\n    </div>\n    <div class=\"col-1\"></div>\n  </div>\n</div>\n<div class=\"row\">\n  <div class=\"col-12\" *ngFor=\"let item of conversacion.mensajes; let i=index \">\n    <div class=\"row\" *ngIf=\"lineaDia(item.fecha,i)\">\n      <div class=\"col-12 ngx-utilitario-chat-linea\">\n        <span class=\"ngx-utilitario-chat-linea-span\">\n          {{diferenciaDias(item.fecha)}}\n        </span>\n      </div>\n    </div>\n    <div [ngClass]=\"escogerEstilo(item.tipoMensaje)\">\n      <div>{{item.mensaje}}</div>\n      <div>{{item.hora}}\n        <span *ngIf=\"estadoMensajeEnviado(item.estadoMensaje, item.tipoMensaje)\" class=\"ngx-utilitario-msj-enviado\">\n          <i class=\"fa fa-check\"></i>\n        </span>\n        <span *ngIf=\"estadoMensajeRecibido(item.estadoMensaje, item.tipoMensaje)\" class=\"ngx-utilitario-msj-recibido\">\n          <i class=\"fa fa-check\"></i>\n          <i class=\"fa fa-check\"></i>\n        </span>\n        <span *ngIf=\"estadoMensajeLeido(item.estadoMensaje, item.tipoMensaje)\" class=\"ngx-utilitario-msj-leido\">\n          <i class=\"fa fa-check\"></i>\n          <i class=\"fa fa-check\"></i>\n        </span>\n      </div>\n    </div>\n  </div>\n</div>\n\n<ngx-utilitario-chat-detalle-agregar (nuevoMensaje)=\"enviarMensaje($event)\"></ngx-utilitario-chat-detalle-agregar>",
                        styles: [".ngx-utilitario-chat-linea{display:block;text-align:center;overflow:hidden;white-space:nowrap}.ngx-utilitario-chat-linea>span{position:relative;display:inline-block}.ngx-utilitario-chat-linea>span:after,.ngx-utilitario-chat-linea>span:before{content:\"\";position:absolute;top:50%;width:40rem;height:.08rem;background:#9e9e9e}.ngx-utilitario-chat-linea>span:before{right:100%;margin-right:15px}.ngx-utilitario-chat-linea>span:after{left:100%;margin-left:15px}.img-height-3-7{height:3.7rem}"]
                    }] }
        ];
        /** @nocollapse */
        ChatConversacionComponent.ctorParameters = function () { return []; };
        ChatConversacionComponent.propDecorators = {
            conversacion: [{ type: i0.Input }],
            nuevoMensaje: [{ type: i0.Output }]
        };
        return ChatConversacionComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ChatDetalleAgregarComponent = /** @class */ (function () {
        function ChatDetalleAgregarComponent(formBuilder) {
            this.formBuilder = formBuilder;
            this.nuevoMensaje = new i0.EventEmitter();
        }
        /**
         * @return {?}
         */
        ChatDetalleAgregarComponent.prototype.ngOnInit = /**
         * @return {?}
         */
            function () {
                this.createForm();
            };
        /**
         * @return {?}
         */
        ChatDetalleAgregarComponent.prototype.createForm = /**
         * @return {?}
         */
            function () {
                this.mensajeForm = this.formBuilder.group({
                    mensaje: '',
                });
            };
        /**
         * @return {?}
         */
        ChatDetalleAgregarComponent.prototype.enviarMensaje = /**
         * @return {?}
         */
            function () {
                this.nuevoMensaje.emit(this.mensajeForm.controls['mensaje'].value);
            };
        ChatDetalleAgregarComponent.decorators = [
            { type: i0.Component, args: [{
                        selector: 'ngx-utilitario-chat-detalle-agregar',
                        template: "<form [formGroup]=\"mensajeForm\">\n  <input formControlName=\"mensaje\">\n</form>\n<button (click)=\"enviarMensaje()\">enviar</button>",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ChatDetalleAgregarComponent.ctorParameters = function () {
            return [
                { type: forms.FormBuilder }
            ];
        };
        ChatDetalleAgregarComponent.propDecorators = {
            nuevoMensaje: [{ type: i0.Output }]
        };
        return ChatDetalleAgregarComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxUtilitarioChatModule = /** @class */ (function () {
        function NgxUtilitarioChatModule() {
        }
        NgxUtilitarioChatModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [ChatComponent, ChatBusquedaComponent, ChatListaComponent, ChatDetalleComponent, ChatConversacionComponent, ChatDetalleAgregarComponent],
                        imports: [
                            common.CommonModule,
                            forms.ReactiveFormsModule
                        ],
                        exports: [
                            ChatComponent
                        ]
                    },] }
        ];
        return NgxUtilitarioChatModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxUtilitarioRcltModule = /** @class */ (function () {
        function NgxUtilitarioRcltModule() {
        }
        NgxUtilitarioRcltModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [CardsComponent, CardsImgTextComponent, RepeatIconComponent, NumberToArrayPipe, CardsImgTextNdivComponent, ModalComponent],
                        imports: [
                            common.CommonModule,
                            NgxUtilitarioChatModule
                        ],
                        exports: [
                            /**
                             * component
                             *  */
                            CardsComponent,
                            CardsImgTextComponent,
                            RepeatIconComponent,
                            CardsImgTextNdivComponent,
                            ModalComponent,
                            /**
                             * pipes
                             *  */
                            NumberToArrayPipe
                        ]
                    },] }
        ];
        return NgxUtilitarioRcltModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /** @enum {number} */
    var EEstadoChat = {
        conectado: 1,
        desconectado: 0,
    };
    EEstadoChat[EEstadoChat.conectado] = 'conectado';
    EEstadoChat[EEstadoChat.desconectado] = 'desconectado';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgxUtilitarioRcltModule = NgxUtilitarioRcltModule;
    exports.NgxUtilitarioChatModule = NgxUtilitarioChatModule;
    exports.Fecha = Fecha;
    exports.EEstadoChat = EEstadoChat;
    exports.EEstadoMensaje = EEstadoMensaje;
    exports.ETipoMensaje = ETipoMensaje;
    exports.ɵe = CardsImgTextNdivComponent;
    exports.ɵb = CardsImgTextComponent;
    exports.ɵa = CardsComponent;
    exports.ɵi = ChatBusquedaComponent;
    exports.ɵl = ChatConversacionComponent;
    exports.ɵm = ChatDetalleAgregarComponent;
    exports.ɵk = ChatDetalleComponent;
    exports.ɵj = ChatListaComponent;
    exports.ɵh = ChatComponent;
    exports.ɵf = ModalComponent;
    exports.ɵg = ModalService;
    exports.ɵd = NumberToArrayPipe;
    exports.ɵc = RepeatIconComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-utilitario-rclt.umd.js.map