export declare class Fecha {
    now: Date;
    constructor();
    /**
     * Compara si la fecha1 es mayor a la fecha2 si no se envia la fecha2 se tomara la fecha actual
     * @param fecha1
     * @param fecha2
     */
    compararFechas(fecha1: Date, fecha2?: Date): boolean;
    /**
     * Cuenta los dias entre la fecha1 y la fecha2. si no se envia la fecha 2 se tomara la fecha actual
     * @param fecha1
     * @param fecha2
     */
    diferenciaDias(fecha1: Date, fecha2?: Date): number;
    /**
     * Cuenta los dias entre la fecha1 y la fecha2. si no se envia la fecha 2 se tomara la fecha actual
     * el formato que se devolvera la fecha "moment"
     * @param fecha1
     * @param fecha2
     * @param format
     */
    textoDiferenciaDias(fecha1: Date, fecha2?: Date, format?: string): string;
    /**
     * Aplicar el formato a una fecha con moment
     * L    = Date (in local format)
     * LL   = Month name, day of month, year
     * LLL  = Month name, day of month, year, time
     * LLLL = Day of week, month name, day of month, year, time
     * LT   = Time (without seconds)
     * LTS  = Time (with seconds)
     * H HH = Time (with seconds)
     * @param fecha
     * @param format
     */
    format(fecha: Date, format: string): string;
}
