import { OnInit, EventEmitter } from '@angular/core';
import { Fecha } from '../../../utilitario/fecha';
import { IChatConversacion } from '../../dto/ichat-conversacion';
export declare class ChatConversacionComponent implements OnInit {
    conversacion: IChatConversacion;
    nuevoMensaje: EventEmitter<any>;
    fecha: Fecha;
    constructor();
    ngOnInit(): void;
    lineaDia(fecha: any, index: any): boolean;
    diferenciaDias(fecha: any): string;
    escogerEstilo(tipoMensaje: any): "float-left" | "float-right";
    estadoMensajeEnviado(estado: any, tipoMensaje: any): boolean;
    estadoMensajeRecibido(estado: any, tipoMensaje: any): boolean;
    estadoMensajeLeido(estado: any, tipoMensaje: any): boolean;
    enviarMensaje(mensaje: any): void;
}
